import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _get from 'babel-runtime/helpers/get';
import _inherits from 'babel-runtime/helpers/inherits';
/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

import UnifiedSyntax from 'aesthetic/unified';
import formatFontFace from 'aesthetic/lib/helpers/formatFontFace';
import { css } from 'glamor';
import GlamorAdapter from './NativeAdapter';

var UnifiedGlamorAdapter = function (_GlamorAdapter) {
  _inherits(UnifiedGlamorAdapter, _GlamorAdapter);

  function UnifiedGlamorAdapter() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, UnifiedGlamorAdapter);

    var _this = _possibleConstructorReturn(this, (UnifiedGlamorAdapter.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter)).call(this, options));

    _this.handleFontFace = function (styleSheet, style, fontFamily) {
      style.forEach(function (face) {
        css.fontFace(formatFontFace(face));
      });
    };

    _this.handleKeyframe = function (styleSheet, style, animationName) {
      _this.syntax.keyframesCache[animationName] = css.keyframes(animationName, style);
    };

    _this.handleProperty = function (declaration, style, property) {
      if (property === 'animationName') {
        declaration[property] = _this.syntax.injectKeyframes(style, _this.syntax.keyframesCache).join(', ');
      } else {
        declaration[property] = style;
      }
    };

    _this.handleSelector = function (declaration, style, selector) {
      declaration[selector.charAt(0) === '>' ? '&' + selector : selector] = style;
    };

    _this.syntax = new UnifiedSyntax();
    _this.syntax.on('property', _this.handleProperty).on('selector', _this.handleSelector).on('@charset', _this.syntax.createUnsupportedHandler('@charset')).on('@font-face', _this.handleFontFace).on('@import', _this.syntax.createUnsupportedHandler('@import')).on('@keyframes', _this.handleKeyframe).on('@namespace', _this.syntax.createUnsupportedHandler('@namespace')).on('@page', _this.syntax.createUnsupportedHandler('@page')).on('@viewport', _this.syntax.createUnsupportedHandler('@viewport'));
    return _this;
  }

  _createClass(UnifiedGlamorAdapter, [{
    key: 'create',
    value: function create(styleSheet) {
      return _get(UnifiedGlamorAdapter.prototype.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter.prototype), 'create', this).call(this, this.syntax.convert(styleSheet));
    }
  }]);

  return UnifiedGlamorAdapter;
}(GlamorAdapter);

export default UnifiedGlamorAdapter;