'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _unified = require('aesthetic/unified');

var _unified2 = _interopRequireDefault(_unified);

var _formatFontFace = require('aesthetic/lib/helpers/formatFontFace');

var _formatFontFace2 = _interopRequireDefault(_formatFontFace);

var _glamor = require('glamor');

var _NativeAdapter = require('./NativeAdapter');

var _NativeAdapter2 = _interopRequireDefault(_NativeAdapter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var UnifiedGlamorAdapter = function (_GlamorAdapter) {
  (0, _inherits3.default)(UnifiedGlamorAdapter, _GlamorAdapter);

  function UnifiedGlamorAdapter() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, UnifiedGlamorAdapter);

    var _this = (0, _possibleConstructorReturn3.default)(this, (UnifiedGlamorAdapter.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter)).call(this, options));

    _this.handleFontFace = function (styleSheet, style, fontFamily) {
      style.forEach(function (face) {
        _glamor.css.fontFace((0, _formatFontFace2.default)(face));
      });
    };

    _this.handleKeyframe = function (styleSheet, style, animationName) {
      _this.syntax.keyframesCache[animationName] = _glamor.css.keyframes(animationName, style);
    };

    _this.handleProperty = function (declaration, style, property) {
      if (property === 'animationName') {
        declaration[property] = _this.syntax.injectKeyframes(style, _this.syntax.keyframesCache).join(', ');
      } else {
        declaration[property] = style;
      }
    };

    _this.handleSelector = function (declaration, style, selector) {
      declaration[selector.charAt(0) === '>' ? '&' + selector : selector] = style;
    };

    _this.syntax = new _unified2.default();
    _this.syntax.on('property', _this.handleProperty).on('selector', _this.handleSelector).on('@charset', _this.syntax.createUnsupportedHandler('@charset')).on('@font-face', _this.handleFontFace).on('@import', _this.syntax.createUnsupportedHandler('@import')).on('@keyframes', _this.handleKeyframe).on('@namespace', _this.syntax.createUnsupportedHandler('@namespace')).on('@page', _this.syntax.createUnsupportedHandler('@page')).on('@viewport', _this.syntax.createUnsupportedHandler('@viewport'));
    return _this;
  }

  (0, _createClass3.default)(UnifiedGlamorAdapter, [{
    key: 'create',
    value: function create(styleSheet) {
      return (0, _get3.default)(UnifiedGlamorAdapter.prototype.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter.prototype), 'create', this).call(this, this.syntax.convert(styleSheet));
    }
  }]);
  return UnifiedGlamorAdapter;
}(_NativeAdapter2.default);

exports.default = UnifiedGlamorAdapter;